Backend API
<template>
<div id="list-demo">
<div class="widget-container">
<DxList
:data-source="plannedTasks"
key-expr="id"
:repaint-changes-only="true"
>
<DxItemDragging
data="plannedTasks"
:allow-reordering="true"
:on-drag-start="onDragStart"
:on-add="onAdd"
:on-remove="onRemove"
:on-reorder="onReorder"
group="tasks"
/>
</DxList>
<DxList
:data-source="doingTasks"
key-expr="id"
:repaint-changes-only="true"
>
<DxItemDragging
data="doingTasks"
:allow-reordering="true"
:on-drag-start="onDragStart"
:on-add="onAdd"
:on-remove="onRemove"
:on-reorder="onReorder"
group="tasks"
/>
</DxList>
</div>
</div>
</template>
<script setup lang="ts">
import { ref, type Ref } from 'vue';
import DxList, { DxItemDragging } from 'devextreme-vue/list';
import * as data from './data.ts';
type Task = { id: number, text: string };
const doingTasks = ref<Task[]>(data.doingTasks);
const plannedTasks = ref<Task[]>(data.plannedTasks);
const tasks: Record<string, Ref<Task[]>> = { doingTasks, plannedTasks };
function onDragStart(e: Record<string, any>) {
e.itemData = tasks[e.fromData].value[e.fromIndex];
}
function onAdd(e: Record<string, any>) {
const newData = [...tasks[e.toData].value];
newData.splice(e.toIndex, 0, e.itemData);
tasks[e.toData].value = newData;
}
function onRemove(e: Record<string, any>) {
const newData = [...tasks[e.fromData].value];
newData.splice(e.fromIndex, 1);
tasks[e.fromData as string].value = newData;
}
function onReorder(e: Record<string, any>) {
onRemove(e);
onAdd(e);
}
</script>
<style>
.widget-container {
display: flex;
}
.widget-container > * {
height: 400px;
width: 50%;
padding: 10px;
}
.dx-scrollview-content {
min-height: 380px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const doingTasks = [{ id: 1, text: 'Prepare 2026 Financial' },
{ id: 2, text: 'Prepare 2026 Marketing Plan' },
{ id: 3, text: 'Update Personnel Files' },
{ id: 4, text: 'Review Health Insurance Options Under the Affordable Care Act' }];
export const plannedTasks = [{ id: 5, text: 'New Brochures' },
{ id: 6, text: '2026 Brochure Designs' },
{ id: 7, text: 'Brochure Design Review' },
{ id: 8, text: 'Website Re-Design Plan' },
{ id: 9, text: 'Rollout of New Website and Marketing Brochures' },
{ id: 10, text: 'Create 2022 Sales Report' },
{ id: 11, text: 'Direct vs Online Sales Comparison Report' },
{ id: 12, text: 'Review 2022 Sales Report and Approve 2026 Plans' },
{ id: 13, text: 'Submit Signed NDA' },
{ id: 14, text: 'Update Revenue Projections' },
{ id: 15, text: 'Review Revenue Projections' },
{ id: 16, text: 'Comment on Revenue Projections' },
{ id: 17, text: 'Scan Health Insurance Forms' },
{ id: 18, text: 'Sign Health Insurance Forms' },
{ id: 19, text: 'Follow up with West Coast Stores' },
{ id: 20, text: 'Follow up with East Coast Stores' },
{ id: 21, text: 'Submit Refund Report for 2026 Recall' },
{ id: 22, text: 'Give Final Approval for Refunds' },
{ id: 23, text: 'Prepare Product Recall Report' },
{ id: 24, text: 'Review Product Recall Report by Engineering Team' },
{ id: 25, text: 'Review Training Course for any Omissions' },
{ id: 26, text: 'Review Overtime Report' },
{ id: 27, text: 'Submit Overtime Request Forms' },
{ id: 28, text: 'Overtime Approval Guidelines' },
{ id: 29, text: 'Create Report on Customer Feedback' },
{ id: 30, text: 'Review Customer Feedback Report' }];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
The following steps describe how to configure this functionality:
-
Enable item drag and drop
Set the itemDragging.allowReordering to true. -
Add the lists to the same group
Set the group property of both components to the same value to allow a user to drag and drop items between them. -
Reorder list items in code
Use the onDragStart event handler to store the dragged item's data. When a user drops the item, the onRemove and onAdd functions allow you to remove the item from its initial position and add it to the new location.

Backend API
import React, { useCallback, useState } from 'react';
import List, { ItemDragging } from 'devextreme-react/list';
import type { IItemDraggingProps } from 'devextreme-react/list';
import type { AddEvent, DragStartEvent, RemoveEvent, ReorderEvent } from 'devextreme/ui/sortable';
import { plannedTasks, doingTasks } from './data.ts';
import type { Task } from './types.ts';
const App = () => {
const [plannedTasksState, setPlannedTasksState] = useState<Task[]>(plannedTasks);
const [doingTasksState, setDoingTasksState] = useState<Task[]>(doingTasks);
const onDragStart = useCallback<NonNullable<IItemDraggingProps['onDragStart']>>((e: DragStartEvent): void => {
e.itemData = e.fromData === 'plannedTasks' ? plannedTasksState[e.fromIndex] : doingTasksState[e.fromIndex];
}, [plannedTasksState, doingTasksState]);
const onAdd = useCallback<NonNullable<IItemDraggingProps['onAdd']>>((e: AddEvent): void => {
const tasks = e.toData === 'plannedTasks' ? plannedTasksState : doingTasksState;
const updatedTasks = [...tasks];
updatedTasks.splice(e.toIndex, 0, e.itemData);
if (e.toData === 'plannedTasks') {
setPlannedTasksState(updatedTasks);
} else {
setDoingTasksState(updatedTasks);
}
}, [plannedTasksState, doingTasksState]);
const onRemove = useCallback<NonNullable<IItemDraggingProps['onRemove']>>((e: RemoveEvent): void => {
const tasks: Task[] = e.fromData === 'plannedTasks' ? plannedTasksState : doingTasksState;
const updatedTasks: Task[] = [...tasks];
updatedTasks.splice(e.fromIndex, 1);
if (e.fromData === 'plannedTasks') {
setPlannedTasksState(updatedTasks);
} else {
setDoingTasksState(updatedTasks);
}
}, [plannedTasksState, doingTasksState]);
const onReorder = useCallback<NonNullable<IItemDraggingProps['onReorder']>>((e: ReorderEvent): void => {
if (e.fromData === e.toData) {
const updateTasks = (tasks: Task[]): Task[] => {
const updatedTasks: Task[] = [...tasks];
const [movedTask] = updatedTasks.splice(e.fromIndex, 1);
updatedTasks.splice(e.toIndex, 0, movedTask);
return updatedTasks;
};
if (e.fromData === 'plannedTasks') {
setPlannedTasksState((prevTasks: Task[]): Task[] => updateTasks(prevTasks));
} else {
setDoingTasksState((prevTasks: Task[]): Task[] => updateTasks(prevTasks));
}
} else {
onRemove(e as RemoveEvent);
onAdd(e as AddEvent);
}
}, [onAdd, onRemove]);
return (
<div className="widget-container">
<List
dataSource={plannedTasksState}
keyExpr="id"
repaintChangesOnly={true}
>
<ItemDragging
allowReordering={true}
group="tasks"
data="plannedTasks"
onDragStart={onDragStart}
onAdd={onAdd}
onRemove={onRemove}
onReorder={onReorder}>
</ItemDragging>
</List>
<List
dataSource={doingTasksState}
keyExpr="id"
repaintChangesOnly={true}
>
<ItemDragging
allowReordering={true}
group="tasks"
data="doingTasks"
onDragStart={onDragStart}
onAdd={onAdd}
onRemove={onRemove}
onReorder={onReorder}>
</ItemDragging>
</List>
</div>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import List, { ItemDragging } from 'devextreme-react/list';
import { plannedTasks, doingTasks } from './data.js';
const App = () => {
const [plannedTasksState, setPlannedTasksState] = useState(plannedTasks);
const [doingTasksState, setDoingTasksState] = useState(doingTasks);
const onDragStart = useCallback(
(e) => {
e.itemData =
e.fromData === 'plannedTasks'
? plannedTasksState[e.fromIndex]
: doingTasksState[e.fromIndex];
},
[plannedTasksState, doingTasksState],
);
const onAdd = useCallback(
(e) => {
const tasks = e.toData === 'plannedTasks' ? plannedTasksState : doingTasksState;
const updatedTasks = [...tasks];
updatedTasks.splice(e.toIndex, 0, e.itemData);
if (e.toData === 'plannedTasks') {
setPlannedTasksState(updatedTasks);
} else {
setDoingTasksState(updatedTasks);
}
},
[plannedTasksState, doingTasksState],
);
const onRemove = useCallback(
(e) => {
const tasks = e.fromData === 'plannedTasks' ? plannedTasksState : doingTasksState;
const updatedTasks = [...tasks];
updatedTasks.splice(e.fromIndex, 1);
if (e.fromData === 'plannedTasks') {
setPlannedTasksState(updatedTasks);
} else {
setDoingTasksState(updatedTasks);
}
},
[plannedTasksState, doingTasksState],
);
const onReorder = useCallback(
(e) => {
if (e.fromData === e.toData) {
const updateTasks = (tasks) => {
const updatedTasks = [...tasks];
const [movedTask] = updatedTasks.splice(e.fromIndex, 1);
updatedTasks.splice(e.toIndex, 0, movedTask);
return updatedTasks;
};
if (e.fromData === 'plannedTasks') {
setPlannedTasksState((prevTasks) => updateTasks(prevTasks));
} else {
setDoingTasksState((prevTasks) => updateTasks(prevTasks));
}
} else {
onRemove(e);
onAdd(e);
}
},
[onAdd, onRemove],
);
return (
<div className="widget-container">
<List
dataSource={plannedTasksState}
keyExpr="id"
repaintChangesOnly={true}
>
<ItemDragging
allowReordering={true}
group="tasks"
data="plannedTasks"
onDragStart={onDragStart}
onAdd={onAdd}
onRemove={onRemove}
onReorder={onReorder}
></ItemDragging>
</List>
<List
dataSource={doingTasksState}
keyExpr="id"
repaintChangesOnly={true}
>
<ItemDragging
allowReordering={true}
group="tasks"
data="doingTasks"
onDragStart={onDragStart}
onAdd={onAdd}
onRemove={onRemove}
onReorder={onReorder}
></ItemDragging>
</List>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Task } from './types.ts';
export const doingTasks: Task[] = [{ id: 1, text: 'Prepare 2026 Financial' },
{ id: 2, text: 'Prepare 2026 Marketing Plan' },
{ id: 3, text: 'Update Personnel Files' },
{ id: 4, text: 'Review Health Insurance Options Under the Affordable Care Act' }];
export const plannedTasks: Task[] = [{ id: 5, text: 'New Brochures' },
{ id: 6, text: '2026 Brochure Designs' },
{ id: 7, text: 'Brochure Design Review' },
{ id: 8, text: 'Website Re-Design Plan' },
{ id: 9, text: 'Rollout of New Website and Marketing Brochures' },
{ id: 10, text: 'Create 2022 Sales Report' },
{ id: 11, text: 'Direct vs Online Sales Comparison Report' },
{ id: 12, text: 'Review 2022 Sales Report and Approve 2026 Plans' },
{ id: 13, text: 'Submit Signed NDA' },
{ id: 14, text: 'Update Revenue Projections' },
{ id: 15, text: 'Review Revenue Projections' },
{ id: 16, text: 'Comment on Revenue Projections' },
{ id: 17, text: 'Scan Health Insurance Forms' },
{ id: 18, text: 'Sign Health Insurance Forms' },
{ id: 19, text: 'Follow up with West Coast Stores' },
{ id: 20, text: 'Follow up with East Coast Stores' },
{ id: 21, text: 'Submit Refund Report for 2026 Recall' },
{ id: 22, text: 'Give Final Approval for Refunds' },
{ id: 23, text: 'Prepare Product Recall Report' },
{ id: 24, text: 'Review Product Recall Report by Engineering Team' },
{ id: 25, text: 'Review Training Course for any Omissions' },
{ id: 26, text: 'Review Overtime Report' },
{ id: 27, text: 'Submit Overtime Request Forms' },
{ id: 28, text: 'Overtime Approval Guidelines' },
{ id: 29, text: 'Create Report on Customer Feedback' },
{ id: 30, text: 'Review Customer Feedback Report' }];
export type Task = {
id: number;
text: string;
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const doingTasks = [
{ id: 1, text: 'Prepare 2026 Financial' },
{ id: 2, text: 'Prepare 2026 Marketing Plan' },
{ id: 3, text: 'Update Personnel Files' },
{ id: 4, text: 'Review Health Insurance Options Under the Affordable Care Act' },
];
export const plannedTasks = [
{ id: 5, text: 'New Brochures' },
{ id: 6, text: '2026 Brochure Designs' },
{ id: 7, text: 'Brochure Design Review' },
{ id: 8, text: 'Website Re-Design Plan' },
{ id: 9, text: 'Rollout of New Website and Marketing Brochures' },
{ id: 10, text: 'Create 2022 Sales Report' },
{ id: 11, text: 'Direct vs Online Sales Comparison Report' },
{ id: 12, text: 'Review 2022 Sales Report and Approve 2026 Plans' },
{ id: 13, text: 'Submit Signed NDA' },
{ id: 14, text: 'Update Revenue Projections' },
{ id: 15, text: 'Review Revenue Projections' },
{ id: 16, text: 'Comment on Revenue Projections' },
{ id: 17, text: 'Scan Health Insurance Forms' },
{ id: 18, text: 'Sign Health Insurance Forms' },
{ id: 19, text: 'Follow up with West Coast Stores' },
{ id: 20, text: 'Follow up with East Coast Stores' },
{ id: 21, text: 'Submit Refund Report for 2026 Recall' },
{ id: 22, text: 'Give Final Approval for Refunds' },
{ id: 23, text: 'Prepare Product Recall Report' },
{ id: 24, text: 'Review Product Recall Report by Engineering Team' },
{ id: 25, text: 'Review Training Course for any Omissions' },
{ id: 26, text: 'Review Overtime Report' },
{ id: 27, text: 'Submit Overtime Request Forms' },
{ id: 28, text: 'Overtime Approval Guidelines' },
{ id: 29, text: 'Create Report on Customer Feedback' },
{ id: 30, text: 'Review Customer Feedback Report' },
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.widget-container {
display: flex;
}
.widget-container > * {
height: 400px;
width: 50%;
padding: 10px;
}
.dx-scrollview-content {
min-height: 380px;
}
The following steps describe how to configure this functionality:
-
Enable item drag and drop
Set the itemDragging.allowReordering to true. -
Add the lists to the same group
Set the group property of both components to the same value to allow a user to drag and drop items between them. -
Reorder list items in code
Use the onDragStart event handler to store the dragged item's data. When a user drops the item, the onRemove and onAdd functions allow you to remove the item from its initial position and add it to the new location.

Backend API
<div id="list-demo">
<div class="widget-container">
<dx-list
[dataSource]="plannedTasks"
keyExpr="id"
[repaintChangesOnly]="true"
>
<dxo-list-item-dragging
group="tasks"
[data]="plannedTasks"
[allowReordering]="true"
[onDragStart]="onDragStart"
[onAdd]="onAdd"
[onRemove]="onRemove"
[onReorder]="onReorder"
>
</dxo-list-item-dragging>
</dx-list>
<dx-list [dataSource]="doingTasks" keyExpr="id" [repaintChangesOnly]="true">
<dxo-list-item-dragging
group="tasks"
[data]="doingTasks"
[allowReordering]="true"
[onDragStart]="onDragStart"
[onAdd]="onAdd"
[onRemove]="onRemove"
[onReorder]="onReorder"
>
</dxo-list-item-dragging>
</dx-list>
</div>
</div>
import { ChangeDetectionStrategy, Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { DxListModule } from 'devextreme-angular';
import type { DxSortableTypes } from 'devextreme-angular/ui/sortable';
import { Task, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
type DxoItemDraggingProperties = DxSortableTypes.Properties;
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
changeDetection: ChangeDetectionStrategy.Eager,
preserveWhitespaces: true,
imports: [DxListModule],
})
export class AppComponent {
doingTasks: Task[];
plannedTasks: Task[];
constructor(service: Service) {
this.doingTasks = service.getDoingTasks();
this.plannedTasks = service.getPlannedTasks();
}
onDragStart: DxoItemDraggingProperties['onDragStart'] = (e) => {
e.itemData = e.fromData[e.fromIndex];
};
onAdd: DxoItemDraggingProperties['onAdd'] = (e) => {
e.toData.splice(e.toIndex, 0, e.itemData);
};
onRemove: DxoItemDraggingProperties['onRemove'] = (e) => {
e.fromData.splice(e.fromIndex, 1);
};
onReorder: DxoItemDraggingProperties['onReorder'] = (e) => {
this.onRemove(e as DxSortableTypes.RemoveEvent);
this.onAdd(e as DxSortableTypes.AddEvent);
};
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .widget-container {
display: flex;
}
::ng-deep .widget-container > * {
height: 400px;
width: 50%;
padding: 10px;
}
::ng-deep .dx-scrollview-content {
min-height: 380px;
}
import { Injectable } from '@angular/core';
export class Task {
id: number;
text: string;
}
const doingTasks: Task[] = [
{ id: 1, text: 'Prepare 2026 Financial' },
{ id: 2, text: 'Prepare 2026 Marketing Plan' },
{ id: 3, text: 'Update Personnel Files' },
{ id: 4, text: 'Review Health Insurance Options Under the Affordable Care Act' },
];
const plannedTasks: Task[] = [
{ id: 5, text: 'New Brochures' },
{ id: 6, text: '2026 Brochure Designs' },
{ id: 7, text: 'Brochure Design Review' },
{ id: 8, text: 'Website Re-Design Plan' },
{ id: 9, text: 'Rollout of New Website and Marketing Brochures' },
{ id: 10, text: 'Create 2022 Sales Report' },
{ id: 11, text: 'Direct vs Online Sales Comparison Report' },
{ id: 12, text: 'Review 2022 Sales Report and Approve 2026 Plans' },
{ id: 13, text: 'Submit Signed NDA' },
{ id: 14, text: 'Update Revenue Projections' },
{ id: 15, text: 'Review Revenue Projections' },
{ id: 16, text: 'Comment on Revenue Projections' },
{ id: 17, text: 'Scan Health Insurance Forms' },
{ id: 18, text: 'Sign Health Insurance Forms' },
{ id: 19, text: 'Follow up with West Coast Stores' },
{ id: 20, text: 'Follow up with East Coast Stores' },
{ id: 21, text: 'Submit Refund Report for 2026 Recall' },
{ id: 22, text: 'Give Final Approval for Refunds' },
{ id: 23, text: 'Prepare Product Recall Report' },
{ id: 24, text: 'Review Product Recall Report by Engineering Team' },
{ id: 25, text: 'Review Training Course for any Omissions' },
{ id: 26, text: 'Review Overtime Report' },
{ id: 27, text: 'Submit Overtime Request Forms' },
{ id: 28, text: 'Overtime Approval Guidelines' },
{ id: 29, text: 'Create Report on Customer Feedback' },
{ id: 30, text: 'Review Customer Feedback Report' },
{ id: 31, text: 'Customer Feedback Report Analysis' },
{ id: 32, text: 'Prepare Shipping Cost Analysis Report' },
{ id: 33, text: 'Complete Shipper Selection Form' },
{ id: 34, text: 'Upgrade Server Hardware' },
{ id: 35, text: 'Upgrade Personal Computers' },
{ id: 36, text: 'Approve Personal Computer Upgrade Plan' },
{ id: 37, text: 'Estimate Time Required to Touch-Enable Apps' },
{ id: 38, text: 'Report on Tranistion to Touch-Based Apps' },
{ id: 39, text: 'Try New Touch-Enabled WinForms Apps' },
{ id: 40, text: 'Site Up-Time Report' },
{ id: 41, text: 'Review Site Up-Time Report' },
{ id: 42, text: 'Review Online Sales Report' },
{ id: 43, text: 'Determine New Online Marketing Strategy' },
{ id: 44, text: 'Submit New Website Design' },
{ id: 45, text: 'Create Icons for Website' },
{ id: 46, text: 'Review PSDs for New Website' },
{ id: 47, text: 'Create New Shopping Cart' },
{ id: 48, text: 'Launch New Website' },
{ id: 49, text: 'Update Customer Shipping Profiles' },
{ id: 50, text: 'Create New Shipping Return Labels' },
];
@Injectable()
export class Service {
getDoingTasks(): Task[] {
return doingTasks;
}
getPlannedTasks(): Task[] {
return plannedTasks;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
The following steps describe how to configure this functionality:
-
Enable item drag and drop
Set the itemDragging.allowReordering to true. -
Add the lists to the same group
Set the group property of both components to the same value to allow a user to drag and drop items between them. -
Reorder list items in code
Use the onDragStart event handler to store the dragged item's data. When a user drops the item, the onRemove and onAdd functions allow you to remove the item from its initial position and add it to the new location.